#include <stdio.h>
#include <stdlib.h>

/* FUNZIONE DA REALIZZARE
   ======================

   Una matrice quadrata M si dice "antisimmetrica" se e solo se

   M[i][j] = -M[j][i]

   per ogni coppia di indici validi i,j (attenzione al segno meno). 

   1. Si realizzi una funzione int f(int M[5][5]) che, dato come
      parametro una matrice quadrata M di interi di dimensioni 5x5,
      restituisce 1 se e solo se M e' una matrice antisimmetrica, 0
      altrimenti.

   2. Si crei quindi un main() per testare la funzione realizzata su
      almeno DUE diverse matrici, una antisimmetrica e una no. (Per
      "testare la funzione realizzta" si intende semplicemente
      stampare a video il risultato della funzione applicata alle
      matrici definite).

   Se lo si ritiene utile, è possibile definire ulteriori funzioni
   di supporto.
*/
int f( int M[5][5] )
{
    int i, j;
    for (i=0; i<5; i++) {
        for (j=i; j<5; j++) { /* per evitare confronti inutili
                                 iniziamo da i; era tuttavia possibile
                                 (ed è stato considerato corretto)
                                 anche partire da 0 */
            if (M[i][j] != -M[j][i])
                return 0;
            /* Ho visto diversi errori del tipo:

               if (M[i][j] == -M[j][i]) {
                   return 1;
               } else {
                   return 0;
               }

               o simili. Come spiegato a lezione, un costrutto come
               quello sopra terminerebbe la funzione immediatamente
               alla prima iterazione dei cicli. Trattandosi di un
               errore molto grave su un esercizio estremamente
               semplice, è stato pesantemente penalizzato */
        }
    }
    return 1;
}

void test( int M[5][5], int expect )
{
    int r = f(M);
    if (r == expect) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO\n");
    }
}

int main( void )
{
    int m1[5][5] = {{0, 0, 0, 0, 0},
                    {0, 0, 0, 0, 0},
                    {0, 0, 0, 0, 0},
                    {0, 0, 0, 0, 0},
                    {0, 0, 0, 0, 0}};    
    int expect1 = 1;

    /* Per costruzione, le matrici antisimmetriche hanno sempre zeri
       sulla diagonale */
    int m2[5][5] = {{0, 2, 3, 4, 5},
                    {-2, 0, 13, 21, 33},
                    {-3, -13, 0, 4, 5},
                    {-4, -21, -4, 0, 2},
                    {-5, -33, -5, -2, 0}};
    int expect2 = 1;

    int m3[5][5] = {{0, 2, 3, 4, 5},
                    {-2, 0, 13, 21, 33},
                    {-3, -13, 0, 4, 5},
                    {13, -21, -4, 0, 2},
                    {-5, -33, -5, -2, 0}};
    int expect3 = 0;

    printf("=== Inizio test ===\n");
    test(m1, expect1);
    test(m2, expect2);
    test(m3, expect3);
    printf("=== Fine test ===\n");
        
    return 0;
}
