#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Realizzare la funzione f(s) seguente. La funzione accetta come
   parametro una stringa s, che puo' essere vuota e non deve essere
   modificata. 

   La funzione deve restituire 1 se e solo se la stringa s e' una
   password "valida" secondo una serie di regole. Specificamente la
   funzione deve restituire 1 se valgono TUTTE le condizioni seguenti:

   1. La stringa s ha lunghezza maggiore o uguale a 9

   2. La stringa s non contiene piu' di 3 caratteri consecutivi uguali
   
   3. La stringa s contiene almeno 3 lettere maiuscole
      ('A', ... 'Z')

   4. La stringa s contiene almeno 2 caratteri numerici
      ('0', ... '9')

   Nel caso in cui qualcunq delle condizioni precedenti non sia
   soddisfatta, la funzione restituisce 0.

   E' consentito usare qualunque funzione presente nell'header file
   <string.h> (comunque l'unica che potrebbe essere utile e'
   strlen()).
*/
int f(char *s)
{
    const int n = strlen(s);
    int i;
    int n_maiuscole = 0;
    int n_cifre = 0;
    
    /* prima condizione: lunghezza >= 8 */
    if (n < 9)
        return 0;

    /* seconda condizione: non piu' di 3 caratteri consecutivi uguali */
    for (i=0; i+3<n; i++) { /* L'espressione i+3<n serve ad evitare accessi fuori dalla stringa nel corpo del ciclo. Sarebbe stato un errore eseguire il ciclo "for" con condizione i<n */
        /* Le direttive del preprocessore che seguono (le righe che
           iniziano con #) servivano a me per gestire le varianti di
           questo esercizio */
#if (3 == 2)
        /* Questo blocco viene compilato se il massimo numero di
           caratteri consecutivi uguali e' 2 */
        if ((s[i] == s[i+1]) && (s[i] == s[i+2]))
            return 0;
#elif (3 == 3)
        /* Questo blocco viene compilato se il massimo numero di
           caratteri consecutivi uguali e' 3 */
        if ((s[i] == s[i+1]) && (s[i] == s[i+2]) && (s[i] == s[i+3]))
            return 0;
#endif
    }

    /* terza e quarta condizione */
    for (i=0; i<n; i++) {
        if ((s[i] >= 'A') && (s[i] <= 'Z'))
            n_maiuscole++;
        else {
            if ((s[i] >= '0') && (s[i] <= '9'))
                n_cifre++;
        }
    }
    return ((n_maiuscole >= 3) && (n_cifre >= 2));
}

void test(char *s, int expect)
{
    const int r = f(s);
    if (r == expect) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: s=\"%s\", risultato atteso=%d, risultato ottenuto=%d\n", s, expect, r);
    }
}

int main( void )
{
    test("", 0);
    test("ciao", 0);
    test("123456789101", 0);
    test("PROVA11322", 1);
    test("eSEmPiio112", 1);
    test("non_va_bene", 0);
    test("tttroppe_UGUALIi1", 0);
    return 0;
}
